\set ECHO none

--
-- approximations with multidimensional histograms
--

CREATE TABLE multi (i integer, u uncertain);

INSERT INTO multi VALUES (1, uncertain_parse('c','norm(0,1)'));
INSERT INTO multi VALUES (2, uncertain_parse('cc','prod(norm(0,1),norm(0,1))'));
INSERT INTO multi VALUES (3, uncertain_parse('ccc','prod(norm(0,1),norm(0,1),norm(0,1))'));

-------------------------------------------------------------------------------
-- u_reduce
-------------------------------------------------------------------------------

INSERT INTO multi
  SELECT 10 + i, u_reduce(u, 6)
  FROM multi;

SELECT uncertain_print(u)
FROM multi
WHERE i > 10;

-------------------------------------------------------------------------------
-- probabilities
-------------------------------------------------------------------------------

SELECT
  u_pdf(u, ARRAY[-3.5,-3.5]) AS "2D pdf: -3.5",
  u_pdf(u, ARRAY[-0.5, 0.5]) AS "2D pdf: @2,3",
  u_pdf(u, ARRAY[ 3.5, 3.5]) AS "2D pdf: +3.5"
FROM multi
WHERE i = 12;

SELECT
  u_pdf(u, ARRAY[-3.5,-3.5,-3.5]) AS "3D pdf: -3.5",
  u_pdf(u, ARRAY[-0.5, 0.5,-1.5]) AS "3D pdf: @2,3,1",
  u_pdf(u, ARRAY[ 3.5, 3.5, 3.5]) AS "3D pdf: +3.5"
FROM multi
WHERE i = 13;

SELECT
  u_cdf(u, ARRAY[-3.5,-3.5]) AS "2D cdf: -3.5",
  u_cdf(u, ARRAY[-0.5, 0.5]) AS "2D cdf: @2,3",
  u_cdf(u, ARRAY[ 3.5, 3.5]) AS "2D cdf: +3.5"
FROM multi
WHERE i = 12;

SELECT
  u_cdf(u, ARRAY[-3.5,-3.5,-3.5]) AS "3D cdf: -3.5",
  u_cdf(u, ARRAY[-0.5, 0.5,-1.5]) AS "3D cdf: @2,3,1",
  u_cdf(u, ARRAY[ 3.5, 3.5, 3.5]) AS "3D cdf: +3.5"
FROM multi
WHERE i = 13;

SELECT u_mass(u) FROM multi;

-------------------------------------------------------------------------------

DROP TABLE multi;
