/*
 * debug.h - miscellaneous debugging macros
 * 
 * Orion Project, http://orion.cs.purdue.edu/
 * Copyright (c) 2008 Purdue University
 */

#ifndef DEBUG_H_
#define DEBUG_H_

 /* set to 1 to send debug output to the client */
#define DEBUG_PRINT 0
#if DEBUG_PRINT == 1
#define DPRINTF(format, args...) elog(NOTICE, format, args)
#else
#define DPRINTF(format, args...) ((void) 0)
#endif

#define DEBUGASSERT(x) { \
	int _assertval = (int) (x); \
	if(!_assertval) { \
		fprintf(stderr, "FAILED ASSERTION: (" #x ") = %i\n", _assertval);\
	} \
}

#define DEBUG(fmt, ...) fprintf(stderr, "%s:%d:\t" fmt "\n", __FILE__, __LINE__,##__VA_ARGS__); fflush(stderr);

#endif
