/*
 * errors.h - server error reporting functions
 * 
 * Orion Project, http://orion.cs.purdue.edu/
 * Copyright (c) 2008 Purdue University
 */

#ifndef ERRORS_H_
#define ERRORS_H_

/*
 * Name Strings
 */
#define ERR_PDFTYPE "pdf type"
#define ERR_SQLTYPE "sql type"
#define ERR_DIMCNT  "dimensions"
#define ERR_BINCNT  "histogram bins"
#define ERR_PNTCNT  "data points"

/*
 * Text Representation
 */
void err_pdf_type(char *sqlname, char *str);
void err_pdf_text(const char *pdfname, char *str, char *pos);
void err_pdf_delim(char dlm, char *str);
void err_pdf_extra(char *str, char *pos);
void err_pdf_hdr(char *valname, char *str);

/*
 * Argument Validation
 */
void err_arg_value(char *funcname, char *valname, int32 value);
void err_arg_limit(char *funcname, char *valname, int32 limit, int32 value);

/*
 * Internal Errors (Bugs)
 */
void err_bad_case(char *funcname, char *valname, int32 value);
void err_not_impl(char *funcname, char *valname, int32 value);
void err_custom(char *message, char *hint);

#endif /* ERRORS_H_ */
