--
-- uninstall.sql : Uninstalls Probability Threshold Indexing (PTI) from a DB.
--
-- Orion Project, Purdue University
-- http://orion.cs.purdue.edu/
--

SET search_path TO orion;

DROP TYPE u_pair CASCADE;
DROP FUNCTION u_gt_prob(uncertain, real) CASCADE;
DROP FUNCTION u_lt_prob(uncertain, real) CASCADE;

DROP OPERATOR CLASS pti_ops USING gist CASCADE;

DROP FUNCTION pti_consistent(internal, uncertain ,int2);
DROP FUNCTION pti_union(bytea, internal);
DROP FUNCTION pti_compress(internal);
DROP FUNCTION pti_decompress(internal);
DROP FUNCTION pti_penalty(internal, internal, internal);
DROP FUNCTION pti_picksplit(internal, internal);
DROP FUNCTION pti_same(internal, internal, internal);

RESET search_path;

