/*
 * Orion Project, http://orion.cs.purdue.edu/
 * Copyright (c) 2008 Purdue University
 */

#ifndef OID_FUNCTIONS_H_
#define OID_FUNCTIONS_H_

#include "postgres.h"
#include "executor/spi.h"

/* These functions cache their result, so multiple calls are cheap */
Oid getUncertainOid(void) ;
Oid getUConOid(void) ;
Oid getUDisOid(void) ;
Oid getUOrdOid(void) ;
Oid getUNomOid(void) ;

Oid getU_productOid(void) ;
Oid getU_marginOid(void) ;
Oid getU_floorOid(void) ;
Oid getU_floor_exOid(void) ;
Oid getU_real2histOid(void) ;
Oid getUncertain_parseOid(void) ;

Oid get_u_gt_ucOid(void) ;
Oid get_u_lt_ucOid(void) ;
Oid get_u_gte_ucOid(void) ;
Oid get_u_lte_ucOid(void) ;
Oid get_u_eq_ucOid(void) ;
Oid get_u_neq_ucOid(void) ;

Oid get_u_gt_uuOid(void) ;
Oid get_u_lt_uuOid(void) ;
Oid get_u_gte_uuOid(void) ;
Oid get_u_lte_uuOid(void) ;
Oid get_u_eq_uuOid(void) ;
Oid get_u_neq_uuOid(void) ;

Oid getInt4Oid(void) ;
Oid getNumericOid(void) ;
Oid get_int2Oid(void) ;
Oid get_float4Oid(void) ;
Oid getFloat4Oid(void) ;
Oid getUnknownOid(void) ;
Oid getCStringOid(void) ;

#endif /*OID_FUNCTIONS_H_*/
