/*
 * util.h - Utility functions for rewriter module
 * 
 * Orion Project, http://orion.cs.purdue.edu/
 * Copyright (c) 2008 Purdue University
 */

#ifndef UTIL_H_
#define UTIL_H_

#include "postgres.h"
#include "executor/spi.h"

Oid getTypeOid(char *typename) ;
Oid getFuncOid(char *func) ;

Oid getVarType(Oid relid, AttrNumber attrNum) ;
Oid getConvertFloat4Oid(Oid initialOid) ;

bool isUncertainType(Oid varType) ;
//bool isJointlyDistributed(Oid relid, AttrNumber attnum, int16 *dimnum, int32 *depid) ;
bool isJointlyDistributed(Oid relid, AttrNumber attnum, int16 *dimnum, int32 *depid, int64 *depdim) ;
AttrNumber getAttrNum(int32 depid) ;
char *getConstValue(Const *cExpr) ;
char *getTypeString(Oid relid, int32 depid) ;

void orion_debug_pprint(char *msg, void *obj) ;
void orion_debug_query_pprint(char *msg, Query *q);

int myvasprintf(char **ret, const char *format, va_list args);
int myasprintf(char **ret, const char *format, ...);

#endif /*UTIL_H_*/
