/*
 * orion_bki.h - Orion API for the PostgreSQL backend
 * 
 * Orion Project, http://orion.cs.purdue.edu/
 * Copyright (c) 2008 Purdue University
 */

#ifndef ORION_BKI_H_
#define ORION_BKI_H_

#include "nodes/parsenodes.h"
#include "utils/fmgrtab.h"

extern FmgrBuiltin orion_builtins[];
extern const int orion_nbuiltins;

bool orion_present(void);

/*
 * Function prototypes (backend hooks into Orion).
 */

void orion_dependent(RangeVar *heapRelation, List *attributeList);

Query *transformOrionSelectStmt(Query *qry);

Expr *transformOrionInsertExpr(Expr *expr, Oid final_type, Oid *initial_type, Oid relid, int attrno);

#endif /* ORION_BKI_H_ */
